import Prelude hiding (repeat)


for :: (a -> a) -> Int -> a -> a
for f n z
   | n > 0     = for f (n-1) (f z)
   | otherwise = z

while :: (a -> Bool) -> (a -> a) -> a -> a
while b f z
   | b z == False = z
   | otherwise    = while b f (f z)

repeat :: (a -> a) -> (a -> Bool) -> a -> a
repeat f b z
   | (b . f) z == True = f z
   | otherwise         = repeat f b (f z)

loop :: (a -> a) -> (a -> Bool) -> (a -> a) -> a -> a
loop f b g z
   | (b . f) z == True = f z
   | otherwise         = loop f b g ((g .f) z)


-- should be 80
testfor = for (*2) 4 5

-- should be 32
testwhile = while (<20) (*2) 4

-- should be 54
testrepeat = repeat (*3) (>20) 2

-- should be 20
testloop = loop (/2) (<25) (*1) 100
