-- Berechnet die Exponentialfunktion an der Stelle x
exps :: Float -> [Float]
exps x = exp_ x 1 1 1

-- Hilfsfunktion zur Berechnung der Exponentialfunktion an der Stelle x
-- Parameter:
--  x		= Stelle an der die Funktion berechnet werden soll
--  elemCount 	= Gibt an, das wievielte Element gerade berechnet wird. Dieser
--                Parameter wird fr die iterative Berechnung der Fakultt bentigt.
--  oldVal      = Der letzte berechnete Werte der Summenfolge
--  oldSum	= Die letzte Summe (dieser Wert wird als Parameter mitgegeben, um
--                Mehrfachberechnungen zu vermeiden)
exp_ :: Float -> Float -> Float -> Float -> [Float]
exp_ x elemCount oldVal oldSum = oldSum : (exp_ x (elemCount+1) newVal newSum)
   where
   newVal = oldVal * x / elemCount
   newSum = oldSum + newVal
   
exp2_ :: Float -> [Float]
exp2_ x = [(power x n) / (factorial n) | n <- [0..] ]

exp2_sum :: Float -> [Float]
exp2_sum x = [foldl (+) 0 (take n (exp2_ x)) | n <- [1..] ]

factorial :: Float -> Float
factorial 0 = 1
factorial n = n * factorial (n-1)

power :: Float -> Float -> Float
power x n
  | n == 0 = 1
  | n > 0  = x * (power x (n-1))


expskPref :: Int -> Float -> Float
expskPref k x = last (take k (exps x))

pythTriples :: [(Integer,Integer,Integer)]
pythTriples = [(a,b,c) | c<-[1..], b<-[1..c-1], a<-[1..c-1], a*a + b*b == c*c]

-- diese Funktion berprft ob eine Zahl n eine Primzahl ist
-- ist n eine Primzahl, so wird 1 retouniert, sonst 0
-- ACHTUNG: diese Funktion funktioniert nur fr Zahlen >2
-- da nur die Zahlen bis n/2 berprft werden und die
-- Bedingung n =< (n/2)^2 erst ab 4 gilt (dadurch, dass 3/2
-- abgerundet wird, funktioniert die Funktion fr n >= 3)
isPrime :: Integer -> Int
isPrime n = isPrime_ n (div n 2) 2
	where 
	isPrime_ nr stop cnt
		| mod_wert == 0 = 0
		| mod_wert /= 0 && cnt < stop = isPrime_ n stop (cnt+1)
		| otherwise = 1
		where
		mod_wert = mod n cnt


-- diese Funktion liefert fr ein Zahlentrippel (a,b,c) und
-- eine Zahl n True, wenn mindestens n Zahlen des Tripels
-- prim sind
triplePrime :: Int -> (Integer,Integer,Integer) -> Bool
triplePrime n (a,b,c) = sum_of_primes >= n
	where
	sum_of_primes = (isPrime a) + (isPrime b) + (isPrime c)

-- diese Funktion liefert in einem unendlichen Strom nur jene
-- pythagorischen Trippel die n Primzahlen enthalten
-- Bei n<1 oder n>3 retouniert die Funktion []
-- Anmerkung: es gibt kein Trippel, mit 3 Primzahlen, da jedes
-- Trippel eine gerade Zahl enthlt
primePytTrp :: Int -> [(Integer,Integer,Integer)]
primePytTrp n 
	| n<1 || n>3 = []
	| otherwise  = filter (triplePrime n) pythTriples
